// Datei: Phaserec.c
// Bi-Phasen RC5 Empfnger
// Zwlf Kanle
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor

#include "Phaserec.h"
#include "protos.h"


//Na wenn das man ANSI-C ist
//Statt alle Module einzeln zu compilieren und dann zu linken,
//mssen bei CC5x alle Module included werden !
#include "phase.c"

unsigned char shift;   //Register fr die Abtastung
unsigned char subcode; //Der RC5 Gertecode
unsigned char comcode; //Der RC5 Kommandocode
unsigned char combuf;  //Puffer fr Kommandocode. Fr Verify
unsigned char subbuf;
unsigned char toggle;  //Das empfangene Togglebit

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char by,buf;
 
 CLRWDT;	    //Vor ndern des Prescalers auf Timer0 laut Microchip

//Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b10000010; //Pullups off,Prescaler auf TMR0, 1:8

 TRISA=0b11110000;   //PA3..0 Ausgnge, PA4 Eingang
 TRISB=0b00000000;   //PB7..0 Ausgnge
 PORTB=0x00;
 PORTA=0x00;

 shift=0; //Empfangsregister lschen

 while(1) // Programm-Endlosschleife
  {

   do
    {
     by=PhaseDemod(); //Warten auf eingehende Impulse
    }while(by==0);

   combuf=comcode; //Eben empfangenen Code speichern
   subbuf=subcode;

   do //Code ein zweites mal empfangen
    {
     by=PhaseDemod(); //Warten auf eingehende Impulse
    }while(by==0);


   if(comcode==combuf && subcode==subbuf) //Beide Codes gleich ?
    {
     if(subcode==SUBID) //Stimmt der Gertecode ?
      {

       if(comcode<12) //Gltiger Kanal ?
        {
         if(comcode<8) //Die Ausgnge an PORTB
          {
           buf=PORTB; //Alten Zustand von PORTB lesen
           by=1<<comcode; //Ausgang an die richtige Stelle schieben

           if(toggle==ONE) //Ein Ausgang soll eingeschaltet werden
            {
             buf|=by;       //Bit setzen
            }
           else          //Ein Ausgang soll ausgeschaltet werden
            {
             buf&=~by;      //Bit zurcksetzen
            } 

           PORTB=buf;     //Und ausgeben
          }
         else          //Die Ausgnge an PORTA
          {
           buf=PORTA; //Alten Zustand von PORTA lesen

//Das hier ist Standard C. Kann CC5x aber nicht. Zu kompliziert !??           
//           by=1<<(comcode-8); //Ausgang an die richtige Stelle schieben
// Erst wenn man es auseinandernimmt gehts
           comcode-=8;
           by=1<<comcode; //Ausgang an die richtige Stelle schieben
           
           if(toggle==ONE) //Ein Ausgang soll eingeschaltet werden
            {
             buf|=by;       //Bit setzen
            }
           else          //Ein Ausgang soll ausgeschaltet werden
            {
             buf&=~by;      //Bit zurcksetzen
            } 

           PORTA=buf;     //Und ausgeben
          } 

        }//if comcode<12

      }// ifsubcode==SUBID

    } //if(comcode==combuf && subcode==subbuf)
   
  } //while(1) Endlosschleife

}
